import{__setFunctionName as t,__esDecorate as e,__runInitializers as s,__classPrivateFieldGet as i,__classPrivateFieldSet as n}from"../../_virtual/_tslib.js";import'./../../external/@lit/reactive-element/reactive-element.js';import{html as a}from'./../../external/lit-html/lit-html.js';import{LitElement as o}from'./../../external/lit-element/lit-element.js';import{customElement as l}from'./../../external/@lit/reactive-element/decorators/custom-element.js';import{property as r}from'./../../external/@lit/reactive-element/decorators/property.js';import{state as c}from'./../../external/@lit/reactive-element/decorators/state.js';import{query as h}from'./../../external/@lit/reactive-element/decorators/query.js';import{queryAssignedElements as d}from'./../../external/@lit/reactive-element/decorators/query-assigned-elements.js';import{queryAssignedNodes as m}from'./../../external/@lit/reactive-element/decorators/query-assigned-nodes.js';import{ifDefined as p}from'./../../external/lit-html/directives/if-defined.js';import{classMap as u}from'./../../external/lit-html/directives/class-map.js';import{debounce as f}from"../../common/helpers/events.js";import{BUTTON_KINDS as g,BUTTON_SIZES as v,BUTTON_TYPES as k,BUTTON_ICON_POSITION as y}from"./defs.js";import b from"./button.scss.js";let _=(()=>{var _,E,w,M,$,O,S,j,P,W,C,R,A,z,I,q;let L,B,N,T,Y,D,U,x,F,G,H,J,K,Q,V,X,Z,tt,et=[l("kd-button")],st=[],it=o,nt=[],at=[],ot=[],lt=[],rt=[],ct=[],ht=[],dt=[],mt=[],pt=[],ut=[],ft=[],gt=[],vt=[],kt=[],yt=[],bt=[],_t=[],Et=[],wt=[],Mt=[],$t=[],Ot=[],St=[],jt=[],Pt=[],Wt=[],Ct=[],Rt=[],At=[],zt=[],It=[];return B=class extends it{get internals(){return i(this,_,"f")}set internals(t){n(this,_,t,"f")}get description(){return i(this,E,"f")}set description(t){n(this,E,t,"f")}get type(){return i(this,w,"f")}set type(t){n(this,w,t,"f")}get kind(){return i(this,M,"f")}set kind(t){n(this,M,t,"f")}get href(){return i(this,$,"f")}set href(t){n(this,$,t,"f")}get size(){return i(this,O,"f")}set size(t){n(this,O,t,"f")}get iconPosition(){return i(this,S,"f")}set iconPosition(t){n(this,S,t,"f")}get iconOnly(){return i(this,j,"f")}set iconOnly(t){n(this,j,t,"f")}get disabled(){return i(this,P,"f")}set disabled(t){n(this,P,t,"f")}get destructive(){return i(this,W,"f")}set destructive(t){n(this,W,t,"f")}get value(){return i(this,C,"f")}set value(t){n(this,C,t,"f")}get name(){return i(this,R,"f")}set name(t){n(this,R,t,"f")}get formmethod(){return i(this,A,"f")}set formmethod(t){n(this,A,t,"f")}get _slottedEls(){return i(this,z,"f")}set _slottedEls(t){n(this,z,t,"f")}get _iconEls(){return i(this,I,"f")}set _iconEls(t){n(this,I,t,"f")}get _btnEl(){return i(this,q,"f")}set _btnEl(t){n(this,q,t,"f")}render(){const t={[g.PRIMARY_APP]:"primary-app",[g.PRIMARY_WEB]:"primary-web",[g.SECONDARY]:"secondary",[g.TERTIARY]:"tertiary"}[this.kind],e={button:!0,[`kd-btn--${t}${this.destructive?"-destructive":""}`]:!0,[`kd-btn--${t}`]:!this.destructive,"kd-btn--large":this.size===v.LARGE,"kd-btn--small":this.size===v.SMALL,"kd-btn--medium":this.size===v.MEDIUM,[`kd-btn--icon-${this.iconPosition}`]:!!this.iconPosition&&!this.iconOnly,"kd-btn--icon-center":this._iconEls.length&&this.iconOnly,"icon-only":this._iconEls.length&&this.iconOnly};return a`
      ${this.href&&""!==this.href?a`
            <a
              class=${u(e)}
              href=${this.href}
              ?disabled=${this.disabled}
              aria-label=${p(this.description)}
              title=${p(this.description)}
              @click=${t=>this.handleClick(t)}
            >
              <span>
                <slot @slotchange=${()=>this._handleSlotChange()}></slot>
                <slot
                  name="icon"
                  @slotchange=${()=>this._handleSlotChange()}
                ></slot>
              </span>
            </a>
          `:a`
            <button
              class=${u(e)}
              type=${this.type}
              ?disabled=${this.disabled}
              aria-label=${p(this.description)}
              title=${p(this.description)}
              name=${p(this.name)}
              value=${p(this.value)}
              formmethod=${p(this.formmethod)}
              @click=${t=>this.handleClick(t)}
            >
              <span>
                <slot @slotchange=${()=>this._handleSlotChange()}></slot>
                <slot
                  name="icon"
                  @slotchange=${()=>this._handleSlotChange()}
                ></slot>
              </span>
            </button>
          `}
    `}handleClick(t){this.internals.form&&("submit"===this.type?this.internals.form.requestSubmit():"reset"===this.type&&this.internals.form.reset());const e=new CustomEvent("on-click",{detail:{origEvent:t}});this.dispatchEvent(e)}_testIconOnly(){if(!this._iconEls.length)return!1;return!this._slottedEls.filter((t=>""!==t.textContent.trim())).filter((t=>!t.tagName||t.offsetParent)).length}_handleSlotChange(){this.iconOnly=this._testIconOnly(),this.requestUpdate()}connectedCallback(){super.connectedCallback(),window.addEventListener("resize",f((()=>{this.iconOnly=this._testIconOnly()})))}disconnectedCallback(){window.removeEventListener("resize",f((()=>{this.iconOnly=this._testIconOnly()}))),super.disconnectedCallback()}constructor(){super(...arguments),_.set(this,s(this,nt,this.attachInternals())),E.set(this,(s(this,at),s(this,ot,""))),w.set(this,(s(this,lt),s(this,rt,k.BUTTON))),M.set(this,(s(this,ct),s(this,ht,g.PRIMARY_APP))),$.set(this,(s(this,dt),s(this,mt,""))),O.set(this,(s(this,pt),s(this,ut,v.MEDIUM))),S.set(this,(s(this,ft),s(this,gt,y.CENTER))),j.set(this,(s(this,vt),s(this,kt,!1))),P.set(this,(s(this,yt),s(this,bt,!1))),W.set(this,(s(this,_t),s(this,Et,!1))),C.set(this,(s(this,wt),s(this,Mt,""))),R.set(this,(s(this,$t),s(this,Ot,""))),A.set(this,(s(this,St),s(this,jt,void 0))),z.set(this,(s(this,Pt),s(this,Wt,void 0))),I.set(this,(s(this,Ct),s(this,Rt,void 0))),q.set(this,(s(this,At),s(this,zt,void 0))),s(this,It)}},_=new WeakMap,E=new WeakMap,w=new WeakMap,M=new WeakMap,$=new WeakMap,O=new WeakMap,S=new WeakMap,j=new WeakMap,P=new WeakMap,W=new WeakMap,C=new WeakMap,R=new WeakMap,A=new WeakMap,z=new WeakMap,I=new WeakMap,q=new WeakMap,t(B,"Button"),(()=>{var t;const s="function"==typeof Symbol&&Symbol.metadata?Object.create(null!==(t=it[Symbol.metadata])&&void 0!==t?t:null):void 0;N=[c()],T=[r({type:String})],Y=[r({type:String})],D=[r({type:String})],U=[r({type:String})],x=[r({type:String})],F=[r({type:String})],G=[c()],H=[r({type:Boolean,reflect:!0})],J=[r({type:Boolean,reflect:!0})],K=[r({type:String})],Q=[r({type:String})],V=[r({type:String})],X=[m()],Z=[d({slot:"icon"})],tt=[h(".button")],e(B,null,N,{kind:"accessor",name:"internals",static:!1,private:!1,access:{has:t=>"internals"in t,get:t=>t.internals,set:(t,e)=>{t.internals=e}},metadata:s},nt,at),e(B,null,T,{kind:"accessor",name:"description",static:!1,private:!1,access:{has:t=>"description"in t,get:t=>t.description,set:(t,e)=>{t.description=e}},metadata:s},ot,lt),e(B,null,Y,{kind:"accessor",name:"type",static:!1,private:!1,access:{has:t=>"type"in t,get:t=>t.type,set:(t,e)=>{t.type=e}},metadata:s},rt,ct),e(B,null,D,{kind:"accessor",name:"kind",static:!1,private:!1,access:{has:t=>"kind"in t,get:t=>t.kind,set:(t,e)=>{t.kind=e}},metadata:s},ht,dt),e(B,null,U,{kind:"accessor",name:"href",static:!1,private:!1,access:{has:t=>"href"in t,get:t=>t.href,set:(t,e)=>{t.href=e}},metadata:s},mt,pt),e(B,null,x,{kind:"accessor",name:"size",static:!1,private:!1,access:{has:t=>"size"in t,get:t=>t.size,set:(t,e)=>{t.size=e}},metadata:s},ut,ft),e(B,null,F,{kind:"accessor",name:"iconPosition",static:!1,private:!1,access:{has:t=>"iconPosition"in t,get:t=>t.iconPosition,set:(t,e)=>{t.iconPosition=e}},metadata:s},gt,vt),e(B,null,G,{kind:"accessor",name:"iconOnly",static:!1,private:!1,access:{has:t=>"iconOnly"in t,get:t=>t.iconOnly,set:(t,e)=>{t.iconOnly=e}},metadata:s},kt,yt),e(B,null,H,{kind:"accessor",name:"disabled",static:!1,private:!1,access:{has:t=>"disabled"in t,get:t=>t.disabled,set:(t,e)=>{t.disabled=e}},metadata:s},bt,_t),e(B,null,J,{kind:"accessor",name:"destructive",static:!1,private:!1,access:{has:t=>"destructive"in t,get:t=>t.destructive,set:(t,e)=>{t.destructive=e}},metadata:s},Et,wt),e(B,null,K,{kind:"accessor",name:"value",static:!1,private:!1,access:{has:t=>"value"in t,get:t=>t.value,set:(t,e)=>{t.value=e}},metadata:s},Mt,$t),e(B,null,Q,{kind:"accessor",name:"name",static:!1,private:!1,access:{has:t=>"name"in t,get:t=>t.name,set:(t,e)=>{t.name=e}},metadata:s},Ot,St),e(B,null,V,{kind:"accessor",name:"formmethod",static:!1,private:!1,access:{has:t=>"formmethod"in t,get:t=>t.formmethod,set:(t,e)=>{t.formmethod=e}},metadata:s},jt,Pt),e(B,null,X,{kind:"accessor",name:"_slottedEls",static:!1,private:!1,access:{has:t=>"_slottedEls"in t,get:t=>t._slottedEls,set:(t,e)=>{t._slottedEls=e}},metadata:s},Wt,Ct),e(B,null,Z,{kind:"accessor",name:"_iconEls",static:!1,private:!1,access:{has:t=>"_iconEls"in t,get:t=>t._iconEls,set:(t,e)=>{t._iconEls=e}},metadata:s},Rt,At),e(B,null,tt,{kind:"accessor",name:"_btnEl",static:!1,private:!1,access:{has:t=>"_btnEl"in t,get:t=>t._btnEl,set:(t,e)=>{t._btnEl=e}},metadata:s},zt,It),e(null,L={value:B},et,{kind:"class",name:B.name,metadata:s},null,st),B=L.value,s&&Object.defineProperty(B,Symbol.metadata,{enumerable:!0,configurable:!0,writable:!0,value:s})})(),B.styles=[b],B.shadowRootOptions={...o.shadowRootOptions,delegatesFocus:!0},B.formAssociated=!0,s(B,st),B})();export{_ as Button};
//# sourceMappingURL=button.js.map
