import{__setFunctionName as e,__esDecorate as t,__runInitializers as i,__classPrivateFieldGet as s,__classPrivateFieldSet as a}from"../../_virtual/_tslib.js";import'./../../external/@lit/reactive-element/reactive-element.js';import{html as o}from'./../../external/lit-html/lit-html.js';import{LitElement as n}from'./../../external/lit-element/lit-element.js';import{customElement as d}from'./../../external/@lit/reactive-element/decorators/custom-element.js';import{property as l}from'./../../external/@lit/reactive-element/decorators/property.js';import{state as r}from'./../../external/@lit/reactive-element/decorators/state.js';import'./../../external/@lit/reactive-element/decorators/query-assigned-elements.js';import{classMap as c}from'./../../external/lit-html/directives/class-map.js';import m from"./accordionItem.scss.js";import h from'./../../external/@carbon/icons/es/add/32.js';import p from'./../../external/@carbon/icons/es/subtract/32.js';let u=(()=>{var u,_,v,b,f,k;let g,y,x,$,j,w,S,T,H=[d("kd-accordion-item")],M=[],N=n,O=[],W=[],I=[],q=[],D=[],E=[],C=[],K=[],U=[],A=[],B=[],L=[];return y=class extends N{get opened(){return s(this,u,"f")}set opened(e){a(this,u,e,"f")}get _index(){return s(this,_,"f")}set _index(e){a(this,_,e,"f")}get _showNumber(){return s(this,v,"f")}set _showNumber(e){a(this,v,e,"f")}get _filledHeader(){return s(this,b,"f")}set _filledHeader(e){a(this,b,e,"f")}get _compact(){return s(this,f,"f")}set _compact(e){a(this,f,e,"f")}get _id(){return s(this,k,"f")}set _id(e){a(this,k,e,"f")}open(){this.opened||this._toggleOpenState()}close(){this.opened&&this._toggleOpenState()}_handleClick(e){e.preventDefault(),this._toggleOpenState()}_handleKeypress(e){e.preventDefault()," "!=e.key&&"Enter"!=e.key||this._toggleOpenState()}_toggleOpenState(){this.opened?this.opened=!1:this.opened=!0}get numberTemplate(){return this._showNumber?o`<div class="number">${this._index}</div>`:""}get iconTemplate(){return this.querySelector('[slot="icon"]')?o`<div class="icon"><slot name="icon"></slot></div>`:""}get subtitleTemplate(){return this.querySelector('[slot="subtitle"]')?o`
        <div class="kd-accordion-item-subtitle">
          <slot name="subtitle"></slot>
        </div>
      `:""}get expandIconTemplate(){return this.opened?o`
        <div class="expand-icon">
          <kd-icon .icon="${p}"></kd-icon>
        </div>
      `:o`
        <div class="expand-icon"><kd-icon .icon="${h}"></kd-icon></div>
      `}render(){const e=c({"kd-accordion-item":!0,opened:this.opened,"filled-header":this._filledHeader,compact:this._compact});return o`
      <div class="${e}">
        <div
          class="kd-accordion-item-title"
          aria-controls="kd-accordion-item-body-${this._index}-${this._id}"
          aria-expanded=${this.opened}
          tabindex="${this._index}"
          role="button"
          @click="${e=>this._handleClick(e)}"
          @keypress="${e=>this._handleKeypress(e)}"
          id="kd-accordion-item-title-${this._index}-${this._id}"
        >
          ${this.iconTemplate} ${this.numberTemplate}

          <div class="title">
            <slot name="title"></slot>

            ${this.subtitleTemplate}
          </div>

          ${this.expandIconTemplate}
        </div>

        <div
          class="kd-accordion-item-body"
          id="kd-accordion-item-body-${this._index}-${this._id}"
          aria-labelledby="kd-accordion-item-title-${this._index}-${this._id}"
        >
          <div class="kd-accordion-item-detail">
            <slot name="body"></slot>
          </div>
        </div>
      </div>
    `}constructor(){super(...arguments),u.set(this,i(this,O,!1)),_.set(this,(i(this,W),i(this,I,1))),v.set(this,(i(this,q),i(this,D,!1))),b.set(this,(i(this,E),i(this,C,!1))),f.set(this,(i(this,K),i(this,U,!1))),k.set(this,(i(this,A),i(this,B,crypto.randomUUID()))),i(this,L)}},u=new WeakMap,_=new WeakMap,v=new WeakMap,b=new WeakMap,f=new WeakMap,k=new WeakMap,e(y,"AccordionItem"),(()=>{var e;const i="function"==typeof Symbol&&Symbol.metadata?Object.create(null!==(e=N[Symbol.metadata])&&void 0!==e?e:null):void 0;x=[l({type:Boolean})],$=[r()],j=[r()],w=[r()],S=[r()],T=[r()],t(y,null,x,{kind:"accessor",name:"opened",static:!1,private:!1,access:{has:e=>"opened"in e,get:e=>e.opened,set:(e,t)=>{e.opened=t}},metadata:i},O,W),t(y,null,$,{kind:"accessor",name:"_index",static:!1,private:!1,access:{has:e=>"_index"in e,get:e=>e._index,set:(e,t)=>{e._index=t}},metadata:i},I,q),t(y,null,j,{kind:"accessor",name:"_showNumber",static:!1,private:!1,access:{has:e=>"_showNumber"in e,get:e=>e._showNumber,set:(e,t)=>{e._showNumber=t}},metadata:i},D,E),t(y,null,w,{kind:"accessor",name:"_filledHeader",static:!1,private:!1,access:{has:e=>"_filledHeader"in e,get:e=>e._filledHeader,set:(e,t)=>{e._filledHeader=t}},metadata:i},C,K),t(y,null,S,{kind:"accessor",name:"_compact",static:!1,private:!1,access:{has:e=>"_compact"in e,get:e=>e._compact,set:(e,t)=>{e._compact=t}},metadata:i},U,A),t(y,null,T,{kind:"accessor",name:"_id",static:!1,private:!1,access:{has:e=>"_id"in e,get:e=>e._id,set:(e,t)=>{e._id=t}},metadata:i},B,L),t(null,g={value:y},H,{kind:"class",name:y.name,metadata:i},null,M),y=g.value,i&&Object.defineProperty(y,Symbol.metadata,{enumerable:!0,configurable:!0,writable:!0,value:i})})(),y.styles=[m],i(y,M),y})();export{u as AccordionItem};
//# sourceMappingURL=accordionItem.js.map
